1.1 Using Razorpay APIs
To create an authorisation transaction using Razorpay APIs, you need to:1.1.1 Create a Customer
Razorpay links recurring tokens to customers using a unique identifier generated through the Customer API. You can create customers with basic information such asemail and contact and use them for various Razorpay offerings. The following endpoint creates a customer.
POST /customers
Sample Code
Sample Code
Request Parameters
Request Parameters
name
: string The name of the customer. For example, Gaurav Kumar.email
: string The email address of the customer. For example, gaurav.kumar@example.com.contact
: string The phone number of the customer. For example, 9876543210.fail_existing optional
: string The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter fail_existing to get the existing customer’s details in the response. Possible values:1(default): If a customer with the same details already exists, throws an error.0: If a customer with the same details already exists, fetches details of the existing customer.
notes optional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.Response Parameters
Response Parameters
id
: string The unique identifier of the customer. For example cust_1Aa00000000001.entity
: string The name of the entity. Here, it is customer.name
: string The name of the customer. For example, Gaurav Kumar.email
: string The email address of the customer. For example, gaurav.kumar@example.com.contact
: string The phone number of the customer. For example, 9876543210.notes
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.created_at
: integer A Unix timestamp, at which the customer was created.You can create an order once you create a customer for the payment authorisation.1.1.2 Create an Order
Use the Orders API to create a unique Razorpayorder_id that is associated with the authorisation transaction. The following endpoint creates an order.
POST /orders
Sample Code
Sample Code
Request Parameters
Request Parameters
amount mandatory
: integer Amount in currency subunits.currency mandatory
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.customer_id mandatory
: string The unique identifier of the customer. For example, cust_4xbQrmEoA5WJ01.method mandatory
: string The authorisation method. Here, it is upi.receipt optional
: string A user-entered unique identifier of the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.notesoptional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.token
: Details related to the authorisation such as max amount, frequency and expiry information.max_amount mandatory
: integer The maximum amount that can be debited in a single charge.100 (₹1) and maximum value is 9999900 (₹99,999).expire_at mandatory
: integer The Unix timestamp that indicates when the authorisation transaction must expire. The default value is 10 years and the maximum value allowed is 30 years.frequency mandatory
: string The frequency at which you can charge your customer. Possible values:dailyweeklyfortnightlybimonthlymonthlyquarterlyhalf_yearlyyearlyas_presented
recurring_value optional
: integer Determines the exact date or range of dates for recurring debits. Possible values are:- 1-7 for
weeklyfrequency - 1-31 for
fortnightlyfrequency - 1-31 for
bimonthlyfrequency - 1-31 for
monthlyfrequency - 1-31 for
quarterlyfrequency - 1-31 for
half_yearlyfrequency - 1-31 for
yearlyfrequency and is not applicable for theas_presentedfrequency.
recurring_type optional
: string Determines when the recurring debit can be done. Possible values are:on: Recurring debit happens on the exact day of every month.
recurring_type=on, set the recurring_value parameter to the current date.before: Recurring debit can happen any time before the specified date.after: Recurring debit can happen any time after the specified date.
frequency is monthly, recurring_value is 17 and recurring_type is before, recurring debit can happen between the month’s 1st and 17th. Similarly, if recurring_type is after, recurring debit can only happen on or after the 17th of the month.Response Parameters
Response Parameters
id
: string A unique identifier of the order created. For example order_1Aa00000000001.entity
: string The entity that has been created. Here it is order.amount
: integer Amount in currency subunits. For emandate, the amount should be 0.amount_paid
: integer The amount that has been paid.amount_due
: integer The amount that is yet to be paid.currency
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.receipt
: string A user-entered unique identifier of the order. For example, rcptid #1. You should map this parameter to the order_id sent by Razorpay.status
: string The status of the order.notes
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.created_at
: integer The Unix timestamp at which the order was created.Error Response Parameters
Error Response Parameters
1.1.3. Create an Authorisation Payment
Create a payment checkout form for customers to make Authorisation Transaction and register their mandate. You can use the Handler Function or Callback URL.UPI Intent
UPI Intent
UPI Collect
UPI Collect
Additional Checkout Fields
customer_id mandatory
: string Unique identifier of the customer created in the first step.
order_id mandatory
: string Unique identifier of the order created in the second step.
recurring mandatory
: string Determines if the recurring payment is enabled or not. Possible values:
1: Recurring payment is enabled.preferred: Use this if you want to allow recurring payments and one-time payment in the same flow.
Error Response Parameters
Error Response Parameters
adequate_funds_not_available_blocked
adequate_funds_not_available_blocked
- Description: Sufficient unblocked funds not available in customer’s account. Please ask customer to add fund and try again.
- Next Steps: Please ask customer to add sufficient unblocked funds and try again.
bad_request_error
bad_request_error
- Description: Invalid Mandate Sequence Number.
- Next Steps: Retry after some time during the valid cycle.
bank_account_invalid
bank_account_invalid
- Description: Payment failed because Account linked to VPA is invalid.
- Next Steps: Create a new mandate with the customer.
bank_account_validation_failed
bank_account_validation_failed
- Description: Payment was unsuccessful as the details are invalid. Please retry with the right details.
- Next Steps: Ask the customer to retry again.
bank_not_available
bank_not_available
- Description: Payment was unsuccessful as the bank linked to this UPI ID is temporarily unavailable. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
bank_technical_error
bank_technical_error
Temporary Bank Issue
Temporary Bank Issue
- Description: Payment was unsuccessful due to a temporary issue at your bank. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
Bank Declined
Bank Declined
- Description: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
Bank or Wallet Gateway Error
Bank or Wallet Gateway Error
- Description: Payment processing failed due to error at bank or wallet gateway.
- Next Steps: Retry after some time.
General Temporary Issue
General Temporary Issue
- Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
Bank Services Halt
Bank Services Halt
- Description: Payment was unsuccessful due to a temporary halt of services at this bank.
- Next Steps: Retry after some time.
credit_to_beneficiary_failed
credit_to_beneficiary_failed
- Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
debit_declined
debit_declined
- Description: Payment was unsuccessful as it was declined by remitter bank.
- Next Steps: Create a new mandate with the customer.
debit_instrument_blocked
debit_instrument_blocked
- Description: Payment was unsuccessful as the account linked to this UPI ID is blocked. Try using another account.
- Next Steps: Create a new mandate with the customer.
duplicate_mandate_request
duplicate_mandate_request
- Description: Duplicate mandate request. Please try again with another mandate request.
- Next Steps: Please try again with another mandate request.
gateway_technical_error
gateway_technical_error
Bank or Wallet Gateway Error
Bank or Wallet Gateway Error
- Description: Payment processing failed due to error at bank or wallet gateway.
- Next Steps: Retry after some time.
Temporary Issue with Money Deduction
Temporary Issue with Money Deduction
- Description: Payment was unsuccessful due to a temporary issue. If money got deducted, reach out to the seller.
- Next Steps: Retry after some time.
incorrect_pin
incorrect_pin
- Description: You have entered an incorrect PIN on the UPI app. Please retry with the correct PIN.
- Next Steps: Ask the customer to retry with correct PIN.
insufficient_funds
insufficient_funds
- Description: Transaction failed due to insufficient funds.
- Next Steps: Ask the customer to add balance to their account and retry.
invalid_request
invalid_request
- Description: Payment processing failed due to error at bank or wallet gateway.
- Next Steps: Retry after some time.
invalid_response_from_gateway
invalid_response_from_gateway
- Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
invalid_transaction_beneficiary
invalid_transaction_beneficiary
- Description: Beneficiary address resolution failed. Please try again after some time.
- Next Steps: Please try again after some time.
invalid_vpa
invalid_vpa
- Description: You have entered an incorrect UPI ID. Please retry with the correct UPI ID.
- Next Steps: Ask the customer to retry with a valid VPA.
issuer_dispatch_failed
issuer_dispatch_failed
- Description: Payment failed due to some issue at the issuer bank. Please try again after some time.
- Next Steps: Please try again after some time.
limit_exceeded_remitting_bank
limit_exceeded_remitting_bank
- Description: Limit exceeded for remitter bank. Please ask customer to try with another bank account.
- Next Steps: Please ask customer to try with another bank account.
mandate_debit_beyond_psp_amount_cap
mandate_debit_beyond_psp_amount_cap
- Description: Debit amount is beyond payer PSP specified amount cap. Please reduce the amount and try again.
- Next Steps: Please reduce the mandate amount to match customer PSP.
mandate_request_limit_breached
mandate_request_limit_breached
- Description: Maximum number of mandate creation requests exceeded for customer’s bank account. Please wait for some time before initiating new mandate creation requests.
- Next Steps: Please wait for some time before initiating new mandate creation requests.
mobile_number_invalid
mobile_number_invalid
- Description: Registered Mobile number linked to the account has been changed or removed.
- Next Steps: Create a new mandate with the customer.
nature_of_debit_not_allowed
nature_of_debit_not_allowed
- Description: Nature of debit not allowed in customer’s account. Please ask the customer to use a different bank account.
- Next Steps: Please ask the customer to use a different bank account.
no_financial_address_record_found
no_financial_address_record_found
- Description: No financial address record found for this VPA. Please ask customer to try with another bank account.
- Next Steps: Please ask customer to try with other bank account.
no_original_request_found
no_original_request_found
- Description: No mandate details were found in the record during debit. Please try after some time.
- Next Steps: Please try after some time.
payment_collect_request_expired
payment_collect_request_expired
- Description: Payment was unsuccessful as you could not pay with the UPI app within time.
- Next Steps: Retry after some time.
payment_declined
payment_declined
Bank Declined Payment
Bank Declined Payment
- Description: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Ask the customer to retry with other account.
Customer Declined Payment
Customer Declined Payment
- Description: You have declined the payment request on the UPI app. Please retry when you are ready.
- Next Steps: Ask the customer to approve the payment.
payment_failed
payment_failed
- Description: Payment was unsuccessful due to a temporary issue. If amount got deducted, it will be refunded within 5-7 working days.
- Next Steps: Retry after 1 hour.
payment_pending
payment_pending
- Description: The status of your payment is pending. You can either wait or retry to pay successfully.
- Next Steps: Retry after some time.
payment_risk_check_failed
payment_risk_check_failed
- Description: Payment was unsuccessful as your account does not pass the risk checks done by your bank. Try using another account.
- Next Steps: Retry after some time.
payment_timed_out
payment_timed_out
- Description: Payment was unsuccessful as you could not complete it in time.
- Next Steps: Retry after some time.
pre_debit_notification_failed
pre_debit_notification_failed
- Description: Unable to Notify the Customer.
- Next Steps: Retry after some time.
remitter_dispatch_failed
remitter_dispatch_failed
- Description: Payment failed due to some issue at the customer’s. Please try again after some time.
- Next Steps: Please try again after some time.
request_timed_out
request_timed_out
General Timeout - Temporary Issue
General Timeout - Temporary Issue
- Description: Payment was unsuccessful due to a temporary issue. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
Timeout - Bank Declined
Timeout - Bank Declined
- Description: Payment was unsuccessful as it was declined by your bank. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
Timeout - Recurring Payment Creation
Timeout - Recurring Payment Creation
- Description: Payment was unsuccessful as the recurring payment can not be created at this time. Any amount deducted will be refunded within 5-7 working days.
- Next Steps: Retry after some time.
transaction_frequency_limit_exceeded
transaction_frequency_limit_exceeded
- Description: Payment failed. Please try again with another bank account.
- Next Steps: Create a new mandate with the customer.
transaction_limit_exceeded
transaction_limit_exceeded
Amount Limit Exceeded
Amount Limit Exceeded
- Description: Payment failed because Transaction amount limit has exceeded.
- Next Steps: Reach out to the customer to collect the amount.
Bank Account Amount Limit
Bank Account Amount Limit
- Description: Payment was unsuccessful as you exceeded the amount limit on the bank account linked to this UPI id.
- Next Steps: Ask the customer to retry after some time.
transaction_not_allowed
transaction_not_allowed
- Description: Payment was unsuccessful as it was declined by your bank. Reach out to your bank for more details. Try using another account.
- Next Steps: Create a new mandate with the customer.
upi_dummy_payment
upi_dummy_payment
- Description: Payment was a dummy payment for one time mandate registration.
- Next Steps: NA
1.2 Using a Registration Link
Registration Link is an alternate way of creating an authorisation transaction. You can create a registration link using the API or Dashboard.- When you create a registration link, an invoice is automatically issued to the customer. They can use this invoice to make the authorisation payment.
- A registration link should always have an order amount (in paise) the customer is charged when making the authorisation payment. For UPI, the amount must be a minimum of
₹1.
1.2.1 Create a Registration Link
The following endpoint creates a registration link.POST /subscription_registration/auth_links
Sample Code
Sample Code
Request Parameters
Request Parameters
customer
: object Details of the customer to whom the registration link is sent.name mandatory
: string Customer’s name.email mandatory
: string Customer’s email address.contactmandatory
: integer Customer’s contact number.type mandatory
: string In this case, the value is link.amount mandatory
: integer The payment amount in the smallest currency sub-unit.currency mandatory
: string The 3-letter ISO currency code for the payment.description mandatory
: string A description that appears on the hosted page.subscription_registration
: Details of the authorisation transaction.method mandatory
: string The payment method used to make authorisation transaction. Here, it is card.max_amount mandatory
: integer Use to set the maximum amount (in paise) per debit request.100 (₹1) and maximum value is 9999900 (₹99,999).expire_at optional
: integer The Unix timestamp till when you can use the token to charge the customer subsequent payments. The default value is 10 years and the maximum value allowed is 30 years.frequency mandatory
: string The frequency at which you can charge your customer. Possible values:dailyweeklyfortnightlybimonthlymonthlyquarterlyhalf_yearlyyearlyas_presented
recurring_value optional
: integer Determines the exact date or range of dates for recurring debits. Possible values are:- 1-7 for
weeklyfrequency - 1-31 for
fortnightlyfrequency - 1-31 for
bimonthlyfrequency - 1-31 for
monthlyfrequency - 1-31 for
quarterlyfrequency - 1-31 for
half_yearlyfrequency - 1-31 for
yearlyfrequency and is not applicable for theas_presentedfrequency.
recurring_type optional
: string Determines when the recurring debit can be done. Possible values are:on: recurring debit happens on the exact day of every month.before: recurring debit can happens any time before the specified date.after: recurring debit can happens any time after the specified date.
For example, if the frequency ismonthly, recurring_value is17and recurring_type isbefore, recurring debit can happen between the month’s 1st and 17th. Similarly, if recurring_type isafter, recurring debit can only happen on or after the 17th of the month.
sms_notify optional
: boolean Indicates if SMS notifications are to be sent by Razorpay. Possible values:true(default): Notifications are sent by Razorpay .false: Notifications are not sent by Razorpay.
email_notify optional
: boolean Indicates if email notifications are to be sent by Razorpay. Possible values:true(default): Notifications are sent by Razorpay .false: Notifications are not sent by Razorpay.
expire_by optional
: integer The Unix timestamp indicates the expiry of the registration link.receipt optional
: string A unique identifier entered by you for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.notes optional
: object This is a key-value pair that is used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.Response Parameters
Response Parameters
id
: string The unique identifier of the invoice.entity
: string The entity that has been created. Here, it is invoice.receipt
: string A user-entered unique identifier of the invoice.invoice_number
: string Unique number you added for internal reference.customer_id
: string The unique identifier of the customer. For example, cust_BMB3EwbqnqZ2EI.customer_details
: object Details of the customer.id
: string The unique identifier associated with the customer to whom the invoice has been issued.name
: string The customer’s name.email
: string The customer’s email address.contact
: integer The customer’s phone number.billing_address
: string Details of the customer’s billing address.shipping_address
: string Details of the customer’s shipping address.order_id
: string The unique identifier of the order associated with the invoice.line_items
: string Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.payment_id
: string Unique identifier of a payment made against the invoice.status
: string The status of the invoice. Possible values:draftissuedpartially_paidpaidcancelledexpireddeleted
expire_by
: integer The Unix timestamp at which the invoice will expire.issued_at
: integer The Unix timestamp at which the invoice was issued to the customer.paid_at
: integer The Unix timestamp at which the payment was made.cancelled_at
: integer The Unix timestamp at which the invoice was cancelled.expired_at
: integer The Unix timestamp at which the invoice expired.sms_status
: string The delivery status of the SMS notification for the invoice sent to the customer. Possible values:pendingsent
email_status
: string The delivery status of the email notification for the invoice sent to the customer. Possible values:pendingsent
date
: integer Timestamp, in Unix format, that indicates the issue date of the invoice.terms
: string Any terms to be included in the invoice. Maximum of 2048 characters.partial_payment
: boolean Indicates whether the customer can make a partial payment on the invoice. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
amount
: integer Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is ₹299.95, pass the value as 29995.amount_paid
: integer Amount paid by the customer against the invoice.amount_due
: integer The remaining amount to be paid by the customer for the issued invoice.currency
: string The currency associated with the invoice.description
: string A brief description of the invoice.notes
: object Any custom notes added to the invoice. Maximum of 2048 characters.short_url
: string The short URL that is generated. This is the link that can be shared with the customer to receive payments.type
: string Here, it is invoice.comment
: string Any comments to be added in the invoice. Maximum of 2048 characters.1.2.2 Send/Resend Notifications
The following endpoint sends/resends notifications with the short URL to the customer:POST /invoices/:id/notify_by/:medium
Sample Code
Sample Code
Path Parameters
Path Parameters
idmandatory
: string The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, inv_1Aa00000000001.medium mandatory
: string Determines through which medium you want to resend the notification. Possible values:smsemail
Response Parameters
Response Parameters
success
: boolean Indicates whether the notifications were sent successfully. Possible values:true: The notifications were successfully sent via SMS, email or both.false: The notifications were not sent.
1.2.3 Cancel a Registration Link
The following endpoint cancels a registration link.POST /invoices/:id/cancel
issued state.Sample Code
Sample Code
Path Parameter
Path Parameter
id mandatory
: string The unique identifier for the invoice linked to the registration link that you want to cancel. For example, inv_1Aa00000000001.Response Parameters
Response Parameters
id
: string The unique identifier of the invoice.entity
: string The entity that has been created. Here, it is invoice.receipt
: string A user-entered unique identifier of the invoice.invoice_number
: string Unique number you added for internal reference.customer_id
: string The unique identifier of the customer. For example, cust_BMB3EwbqnqZ2EI.customer_details
: object Details of the customer.id
: string The unique identifier associated with the customer to whom the invoice has been issued.name
: string The customer’s name.email
: string The customer’s email address.contact
: integer The customer’s phone number.billing_address
: string Details of the customer’s billing address.shipping_address
: string Details of the customer’s shipping address.order_id
: string The unique identifier of the order associated with the invoice.line_items
: string Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.payment_id
: string Unique identifier of a payment made against the invoice.status
: string The status of the invoice. Possible values:draftissuedpartially_paidpaidcancelledexpireddeleted
expire_by
: integer The Unix timestamp at which the invoice will expire.issued_at
: integer The Unix timestamp at which the invoice was issued to the customer.paid_at
: integer The Unix timestamp at which the payment was made.cancelled_at
: integer The Unix timestamp at which the invoice was cancelled.expired_at
: integer The Unix timestamp at which the invoice expired.sms_status
: string The delivery status of the SMS notification for the invoice sent to the customer. Possible values:pendingsent
email_status
: string The delivery status of the email notification for the invoice sent to the customer. Possible values:pendingsent
date
: integer Timestamp, in Unix format, that indicates the issue date of the invoice.terms
: string Any terms to be included in the invoice. Maximum of 2048 characters.partial_payment
: boolean Indicates whether the customer can make a partial payment on the invoice. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
amount
: integer Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is ₹299.95, pass the value as 29995.amount_paid
: integer Amount paid by the customer against the invoice.amount_due
: integer The remaining amount to be paid by the customer for the issued invoice.currency
: string The currency associated with the invoice.description
: string A brief description of the invoice.notes
: object Any custom notes added to the invoice. Maximum of 2048 characters.short_url
: string The short URL that is generated. This is the link that can be shared with the customer to receive payments.type
: string Here, it is invoice.comment
: string Any comments to be added in the invoice. Maximum of 2048 characters.